diff --git a/web/pgadmin/feature_tests/xss_checks_panels_and_query_tool_test.py b/web/pgadmin/feature_tests/xss_checks_panels_and_query_tool_test.py
index 93971eb86..5cda88be7 100644
--- a/web/pgadmin/feature_tests/xss_checks_panels_and_query_tool_test.py
+++ b/web/pgadmin/feature_tests/xss_checks_panels_and_query_tool_test.py
@@ -9,12 +9,14 @@
 
 import sys
 import random
+import time
 
 from regression.python_test_utils import test_utils
 from regression.feature_utils.base_feature_test import BaseFeatureTest
 from selenium.webdriver import ActionChains
 from selenium.common.exceptions import StaleElementReferenceException, \
     WebDriverException
+from selenium.webdriver.common.by import By
 from regression.feature_utils.locators import QueryToolLocators
 from regression.feature_utils.tree_area_locators import TreeAreaLocators
 
@@ -74,7 +76,6 @@ class CheckForXssFeatureTest(BaseFeatureTest):
         while retry > 0:
             try:
                 self.page.refresh_page()
-                self.page.toggle_open_servers_group()
                 self._tables_node_expandable()
                 self._check_xss_in_dependents_tab()
                 retry = 0
@@ -106,15 +107,13 @@ class CheckForXssFeatureTest(BaseFeatureTest):
             self.server, self.test_db, self.test_table_name)
 
     def _tables_node_expandable(self):
-        self.page.expand_database_node(
-            self.server['name'],
-            self.server['db_password'], self.test_db)
-        self.page.toggle_open_tables_node(self.server['name'],
-                                          self.server['db_password'],
-                                          self.test_db, 'public')
-        self.page.click_a_tree_node(
-            self.test_table_name,
-            TreeAreaLocators.sub_nodes_of_tables_node)
+        self.page.expand_tables_node("Server", self.server['name'],
+                                     self.server['db_password'], self.test_db,
+                                     'public')
+
+        table_node = self.page.check_if_element_exists_with_scroll(
+            TreeAreaLocators.table_node(self.test_table_name))
+        table_node.click()
 
     def _check_xss_in_browser_tree(self):
         print(
@@ -138,6 +137,12 @@ class CheckForXssFeatureTest(BaseFeatureTest):
             file=sys.stderr, end=""
         )
         self.page.click_tab("SQL")
+
+        # Wait till data is displayed in SQL Tab
+        self.assertTrue(self.page.check_if_element_exist_by_xpath(
+            "//*[contains(@class,'CodeMirror-lines') and "
+            "contains(.,'CREATE TABLE')]", 10), "No data displayed in SQL tab")
+
         # Fetch the inner html & check for escaped characters
         source_code = self.page.find_by_xpath(
             "//*[contains(@class,'CodeMirror-lines') and "
@@ -197,7 +202,7 @@ class CheckForXssFeatureTest(BaseFeatureTest):
             "contains(@style, 'top:0px')]"
         )
 
-        cells = result_row.find_elements_by_tag_name('div')
+        cells = result_row.find_elements(By.TAG_NAME, 'div')
 
         # remove first element as it is row number.
         source_code = cells[1].get_attribute('innerHTML')
@@ -239,8 +244,8 @@ class CheckForXssFeatureTest(BaseFeatureTest):
         while retry > 0:
             try:
                 history_ele = self.driver \
-                    .find_element_by_css_selector(
-                        ".query-detail .content-value")
+                    .find_element(By.CSS_SELECTOR,
+                                  ".query-detail .content-value")
                 source_code = history_ele.get_attribute('innerHTML')
                 break
             except StaleElementReferenceException:
@@ -279,7 +284,7 @@ class CheckForXssFeatureTest(BaseFeatureTest):
         )
 
         self.page.find_by_css_selector(".slick-header-column")
-        cells = self.driver.\
+        cells = self.driver. \
             find_elements_by_css_selector(".slick-header-column")
 
         # remove first element as it is row number.
diff --git a/web/pgadmin/feature_tests/xss_checks_pgadmin_debugger_test.py b/web/pgadmin/feature_tests/xss_checks_pgadmin_debugger_test.py
index 79ac785be..c04f1ad0f 100644
--- a/web/pgadmin/feature_tests/xss_checks_pgadmin_debugger_test.py
+++ b/web/pgadmin/feature_tests/xss_checks_pgadmin_debugger_test.py
@@ -58,16 +58,12 @@ class CheckDebuggerForXssFeatureTest(BaseFeatureTest):
                                        self.function_name)
 
     def _function_node_expandable(self):
-        self.page.expand_database_node(
-            self.server['name'],
-            self.server['db_password'], self.test_db)
-        self.page.toggle_open_schema_node(self.server['name'],
-                                          self.server['db_password'],
-                                          self.test_db, 'public')
-        self.page.toggle_open_function_node()
-        self.page.click_a_tree_node(
-            self.function_name + "()",
-            TreeAreaLocators.sub_nodes_of_functions_node)
+        self.page.expand_schema_child_node("Server", self.server['name'],
+                                           self.server['db_password'],
+                                           self.test_db, 'public', "Functions")
+        function_node = self.page.check_if_element_exists_with_scroll(
+            TreeAreaLocators.function_node(self.function_name + "()"))
+        function_node.click()
 
     def _debug_function(self):
         self.page.driver.find_element_by_link_text("Object").click()
diff --git a/web/pgadmin/feature_tests/xss_checks_roles_control_test.py b/web/pgadmin/feature_tests/xss_checks_roles_control_test.py
index 4aeecb4e0..d51632386 100644
--- a/web/pgadmin/feature_tests/xss_checks_roles_control_test.py
+++ b/web/pgadmin/feature_tests/xss_checks_roles_control_test.py
@@ -42,6 +42,8 @@ class CheckRoleMembershipControlFeatureTest(BaseFeatureTest):
                                self.role)
         test_utils.create_role(self.server, "postgres",
                                "<h1>test</h1>")
+        test_utils.grant_role(self.server, "postgres",
+                              self.role, "<h1>test</h1>")
         self.wait = WebDriverWait(self.page.driver, 20)
 
     def runTest(self):
@@ -58,11 +60,13 @@ class CheckRoleMembershipControlFeatureTest(BaseFeatureTest):
                              "<h1>test</h1>")
 
     def _role_node_expandable(self, role):
-        self.page.expand_server_node(
-            self.server['name'], self.server['db_password'])
-        self.page.toggle_open_tree_item('Login/Group Roles')
-        self.page.click_a_tree_node(
-            role, TreeAreaLocators.sub_nodes_of_login_group_node)
+        self.page.expand_server_child_node("Server", self.server['name'],
+                                           self.server['db_password'],
+                                           'Login/Group Roles')
+
+        role_node = self.page.check_if_element_exists_with_scroll(
+            TreeAreaLocators.role_node(role))
+        role_node.click()
 
     def _check_role_membership_control(self):
         self.page.driver.find_element_by_link_text(
@@ -70,24 +74,22 @@ class CheckRoleMembershipControlFeatureTest(BaseFeatureTest):
         property_object = self.wait.until(EC.visibility_of_element_located(
             (By.CSS_SELECTOR, NavMenuLocators.properties_obj_css)))
         property_object.click()
-        WebDriverWait(self.page.driver, 4).until(
+        membership_tab = WebDriverWait(self.page.driver, 4).until(
             EC.presence_of_element_located((
-                By.XPATH, "//a[normalize-space(text())='Membership']")))
-        self.click_membership_tab()
+                By.XPATH, "//span[normalize-space(text())='Membership']")))
+        membership_tab.click()
+
         # Fetch the source code for our custom control
         source_code = self.page.find_by_xpath(
-            "//div[contains(@class,'rolmembership')]"
-        ).get_attribute('innerHTML')
+            "//span[contains(@class,'icon-')]/following-sibling::span"
+        ).text
 
         self._check_escaped_characters(
             source_code,
             '&lt;h1&gt;test&lt;/h1&gt;',
             'Role Membership Control'
         )
-        self.page.find_by_xpath(
-            "//button[contains(@type, 'cancel') and "
-            "contains(.,'Cancel')]"
-        ).click()
+        self.page.find_by_xpath("//button/span[text()='Close']").click()
 
     def _check_escaped_characters(self, source_code, string_to_find, source):
         # For XSS we need to search against element's html code
diff --git a/web/regression/feature_utils/locators.py b/web/regression/feature_utils/locators.py
index 4c57f344b..3c728ca9c 100644
--- a/web/regression/feature_utils/locators.py
+++ b/web/regression/feature_utils/locators.py
@@ -249,8 +249,8 @@ class ConnectToServerDiv:
     password_field = "//input[@id='password']"
 
     ok_button = \
-        "//div [@class='alertify  ajs-modeless ajs-movable ajs-zoom']" \
-        "//button[text()='OK']"
+        "//button[@class='ajs-button btn btn-primary fa fa-check " \
+        "pg-alertify-button']"
 
     error_message = \
         "//form[@id='frmPassword']/div/div//div[@class='alert-text']"
@@ -258,3 +258,12 @@ class ConnectToServerDiv:
     cancel_button = \
         "//div [@class='alertify  ajs-modeless ajs-movable ajs-zoom']" \
         "//button[text()='Cancel']"
+
+
+class PropertyDialogueLocators:
+    # This will contain xpaths for elements in properties dialogue
+    server_dialogue_title = "//div[text()='Create - Server']"
+
+    server_connection_tab = "//button/span[text()='Connection']"
+
+    server_tab_save = "//button/span[text()='Save']"
diff --git a/web/regression/feature_utils/pgadmin_page.py b/web/regression/feature_utils/pgadmin_page.py
index c44f62358..e648bc625 100644
--- a/web/regression/feature_utils/pgadmin_page.py
+++ b/web/regression/feature_utils/pgadmin_page.py
@@ -20,7 +20,7 @@ from selenium.webdriver.support import expected_conditions as EC
 from selenium.webdriver.support.ui import WebDriverWait
 from selenium.webdriver.common.by import By
 from regression.feature_utils.locators import QueryToolLocators, \
-    NavMenuLocators, ConnectToServerDiv
+    NavMenuLocators, ConnectToServerDiv, PropertyDialogueLocators
 from regression.feature_utils.tree_area_locators import TreeAreaLocators
 
 
@@ -37,6 +37,7 @@ class PgadminPage:
         self.timeout = 30
         self.app_start_timeout = 90
 
+    # pgAdmin related methods
     def login_to_app(self, user_detail):
         if not (self.check_if_element_exist_by_xpath(
                 '//a[@id="navbar-user"]', 1)):
@@ -90,60 +91,61 @@ class PgadminPage:
         self.click_element(modal_button)
 
     def add_server(self, server_config):
-        self.find_by_xpath(
-            "//*[@class='aciTreeText' and contains(.,'Servers')]").click()
-
-        if self.driver.name == 'firefox':
-            ActionChains(self.driver).context_click(self.find_by_xpath(
-                "//*[@class='aciTreeText' and contains(.,'Servers')]"))\
-                .perform()
-            ActionChains(self.driver).move_to_element(
-                self.find_by_xpath("//li/span[text()='Create']")).perform()
-            self.find_by_xpath("//li/span[text()='Server...']").click()
-        else:
-            self.driver.find_element_by_link_text("Object").click()
-            ActionChains(self.driver).move_to_element(
-                self.driver.find_element_by_link_text("Create")).perform()
-            self.find_by_partial_link_text("Server...").click()
+        server_group_node = \
+            self.find_by_xpath(TreeAreaLocators.server_group_node("Servers"))
+        ActionChains(self.driver).context_click(server_group_node).perform()
+        ActionChains(self.driver).move_to_element(self.find_by_xpath(
+            TreeAreaLocators.context_menu_element('Create'))).perform()
+        ActionChains(self.driver).move_to_element(self.find_by_xpath(
+            TreeAreaLocators.context_menu_element('Server...'))) \
+            .click().perform()
 
         WebDriverWait(self.driver, 5).until(EC.visibility_of_element_located(
-            (By.XPATH, "//div[text()='Create - Server']")))
+            (By.XPATH, PropertyDialogueLocators.server_dialogue_title)))
 
         # After server dialogue opens
-        self.fill_input_by_field_name("name", server_config['name'],
-                                      loose_focus=True)
-        self.find_by_partial_link_text("Connection").click()
-        self.fill_input_by_field_name("host", server_config['host'])
-        self.fill_input_by_field_name("port", server_config['port'])
-        self.fill_input_by_field_name("username", server_config['username'])
-        self.fill_input_by_field_name("password", server_config['db_password'])
-        WebDriverWait(self.driver, 10).until(EC.element_to_be_clickable(
-            (By.CSS_SELECTOR, "button[type='save'].btn.btn-primary")))
-        self.find_by_css_selector("button[type='save'].btn.btn-primary").\
-            click()
-
-        server_tree_xpath = \
-            "//*[@id='tree']//*[.='" + server_config['name'] + "']"
+        self.fill_input_by_field_name(
+            "name", server_config['name'], input_keys=True)
+        self.find_by_xpath(
+            PropertyDialogueLocators.server_connection_tab).click()
+        self.fill_input_by_field_name(
+            "host", server_config['host'], input_keys=True)
+        self.fill_input_by_field_name(
+            "port", server_config['port'], input_keys=True)
+        self.fill_input_by_field_name(
+            "username", server_config['username'], input_keys=True)
+        self.fill_input_by_field_name(
+            "password", server_config['db_password'], input_keys=True)
+
+        save_btn = WebDriverWait(self.driver, 5).until(
+            EC.element_to_be_clickable(
+                (By.XPATH, PropertyDialogueLocators.server_tab_save)))
+        save_btn.click()
+
+        server_tree_xpath = TreeAreaLocators.server_node(server_config['name'])
         try:
             WebDriverWait(self.driver, 10).until(
                 EC.visibility_of_element_located(
                     (By.XPATH, server_tree_xpath)))
         except TimeoutException:
-            self.toggle_open_servers_group()
+            self.expand_server_group_node("Server")
             WebDriverWait(self.driver, 10).until(
                 EC.visibility_of_element_located(
                     (By.XPATH, server_tree_xpath)))
 
     def open_query_tool(self):
-        self.driver.find_element_by_link_text("Tools").click()
-        tools_menu = self.driver.find_element_by_id('mnu_tools')
+        self.driver.find_element(By.LINK_TEXT, "Tools").click()
+        tools_menu = self.driver.find_element(By.ID, 'mnu_tools')
 
-        query_tool = tools_menu.find_element_by_id('query_tool')
+        query_tool = tools_menu.find_element(By.ID, 'query_tool')
 
         self.enable_menu_item(query_tool, 10)
 
         self.find_by_partial_link_text("Query Tool").click()
 
+        self.wait_for_element_to_be_visible(
+            self.driver, "//div[@id='btn-conn-status']", 5)
+
     def open_view_data(self, table_name):
         self.driver.find_element_by_link_text("Object").click()
         ActionChains(
@@ -259,6 +261,7 @@ class PgadminPage:
                         break
                     else:
                         retry -= 1
+
         if option == 'auto_commit':
             update_execute_option_setting(
                 QueryToolLocators.btn_auto_commit_check_status,
@@ -303,29 +306,33 @@ class PgadminPage:
                 QueryToolLocators.btn_auto_rollback)
 
     def close_data_grid(self):
-        self.driver.switch_to_default_content()
+        self.driver.switch_to.default_content()
         xpath = "//*[@id='dockerContainer']/div/div[3]/div/div[2]/div[1]"
         self.click_element(self.find_by_xpath(xpath))
 
     def remove_server(self, server_config):
         self.driver.switch_to.default_content()
-        server_to_remove = self.find_by_xpath(
-            "//*[@id='tree']//*[.='" + server_config['name'] +
-            "' and @class='aciTreeItem']")
-        self.driver.execute_script(
-            self.js_executor_scrollintoview_arg, server_to_remove)
-        self.click_element(server_to_remove)
-        object_menu_item = self.find_by_partial_link_text("Object")
-        self.click_element(object_menu_item)
-        delete_menu_item = self.find_by_partial_link_text("Remove Server")
-        self.click_element(delete_menu_item)
-        self.click_modal('Yes')
-        time.sleep(1)
+        server_to_remove = self.check_if_element_exists_with_scroll(
+            TreeAreaLocators.server_node(server_config['name']))
+        if server_to_remove:
+            self.driver.execute_script(
+                self.js_executor_scrollintoview_arg, server_to_remove)
+            self.click_element(server_to_remove)
+            object_menu_item = self.find_by_partial_link_text("Object")
+            self.click_element(object_menu_item)
+            delete_menu_item = self.find_by_partial_link_text("Remove Server")
+            self.click_element(delete_menu_item)
+            self.click_modal('Yes')
+            time.sleep(1)
+        else:
+            print("%s Server is not removed", server_config['name'],
+                  file=sys.stderr)
 
+    # TODO - Not used to be deleted
     def select_tree_item(self, tree_item_text):
         item = self.find_by_xpath(
-            "//*[@id='tree']//*[contains(text(), '" + tree_item_text + "')]"
-            "/parent::span[@class='aciTreeItem']")
+            "//*[@id='tree']//*[contains(text(), '" + tree_item_text +
+            "')]/parent::span[@class='aciTreeItem']")
         self.driver.execute_script(self.js_executor_scrollintoview_arg, item)
         # unexpected exception like element overlapping, click attempts more
         # than one time
@@ -340,6 +347,7 @@ class PgadminPage:
                 if attempts == 0:
                     raise e
 
+    # TODO - Not used to be deleted
     def click_a_tree_node(self, element_name, list_of_element):
         """It will click a tree node eg. server, schema, table name etc
         will take server name and list of element where this node lies"""
